#!/usr/bin/env python


import md5
import time


class Common:
    def log(self, message):
        """
        Print a log message if verbose is enabled.
        """

        if self.args.verbose:
            print "[%s] [INFO]  %s" % (time.strftime("%X"), message)


    def warn(self, message):
        """
        Print a warning message.
        """

        print "[%s] [WARN]  %s" % (time.strftime("%X"), message)


    def url_replace_parameter(self, parameter="", value="", newvalue=""):
        if not self.args.injparameter:
            return self.args.url.replace("%s=%s" % (parameter, value),
                                         "%s=%s" % (parameter, newvalue))
        else:
            value = self.args.parameters[self.args.injparameter]
            return self.args.url.replace("%s=%s" % (self.args.injparameter, value),
                                         "%s=%s" % (self.args.injparameter, value + newvalue))


    def hash_page(self, url):
        """
        Connect to the target link or proxy and return the target
        url page hash.
        """

        url = url.replace(" ", "%20")

        try:
            if not self.args.proxy:
                conn = self.args.http(self.args.link, self.args.port)
            else:
                conn = self.args.http(self.args.proxy)

            if self.args.http_method == "GET":
                conn.request(method="GET", url=url, headers=self.args.http_headers)
            elif self.args.http_method == "POST":
                params = url.split("?")[1]
                conn.putrequest("POST", url)
                for header, value in self.args.http_headers.items():
                    conn.putheader(header, value)
                conn.putheader("Content-Type", "application/x-www-form-urlencoded")
                conn.putheader("Content-Length", len(params))
                conn.endheaders()
                conn.send(params)

            response = conn.getresponse()
            page = response.read()
            conn.close()
        except:
            err_msg  = "ERROR: can not connect to the "
            err_msg += "target link or proxy"
            raise Exception, err_msg

        return md5.new(page).hexdigest()
