#!/usr/bin/env python


class SQLMapDump:
    def string(self, header, string):
        if string:
            if '\n' in string:
                print "%s:\n'''\n%s'''\n" % (header, string)
            else:
                print "%s:\t'%s'\n" % (header, string)
        else:
            print "%s:\tNone\n" % header


    def list(self, header, list):
        print "%s [%d]:\n" % (header, len(list))

        list.sort()
        for element in list:
            print "[*] %s" % element
        print


    def db_tables(self, db_tables):
        maxlength = 0
        for tables in db_tables.values():
            for table in tables:
                maxlength = max(maxlength, len(table))

        lines = "-" * (int(maxlength) + 2)

        for db, tables in db_tables.items():
            print "DATABASE: %s" % db
            print "+%s+" % lines

            for table in tables:
                blank_spaces = " " * (maxlength - len(table))
                print  "| %s%s |\n" % (table, blank_spaces),

            print "+%s+\n" % lines


    def table_columns(self, db_table_columns):
        for db, tables in db_table_columns.items():
            if not db:
                db = "All"

            for table, columns in tables.items():
                maxlength1 = 0
                maxlength2 = 0
                for column, coltype in columns.items():
                    maxlength1 = max(maxlength1, len(column))
                    maxlength2 = max(maxlength2, len(coltype))

                maxlength1 = max(maxlength1, len("COLUMN"))
                maxlength2 = max(maxlength2, len("TYPE"))
                lines1 = "-" * (int(maxlength1) + 2)
                lines2 = "-" * (int(maxlength2) + 2)

                print "DATABASE: %s" % db
                print "TABLE: %s" % table
                print "+%s+%s+" % (lines1, lines2)

                blank_spaces1 = " " * (maxlength1 - len("COLUMN"))
                blank_spaces2 = " " * (maxlength2 - len("TYPE"))

                print "| COLUMN%s" % blank_spaces1,
                print "| TYPE%s |" % blank_spaces2
                print "+%s+%s+" % (lines1, lines2)

                for column, coltype in columns.items():
                    blank_spaces1 = " " * (maxlength1 - len(column))
                    blank_spaces2 = " " * (maxlength2 - len(coltype))
                    print "| %s%s" % (column, blank_spaces1),
                    print "| %s%s |" % (coltype, blank_spaces2)

                print "+%s+%s+\n" % (lines1, lines2)


    def table_values(self, db_table_values):
        db = db_table_values['__infos__']['db']
        if not db:
            db = "All"
        table = db_table_values['__infos__']['table']
        count = int(db_table_values['__infos__']['count'])

        break_line = ''
        for column, info in db_table_values.items():
            if column != '__infos__':
                lines = "-" * (int(info['length']) + 2)
                break_line += "+%s" % lines
        break_line += "+"

        print "DATABASE: %s" % db
        print "TABLE: %s" % table

        print break_line

        for column, info in db_table_values.items():
            if column != '__infos__':
                maxlength = int(info['length'])
                blank_spaces = " " * (maxlength - len(column))
                print  "| %s%s" % (column, blank_spaces),

        print "|\n%s" % break_line

        for i in range(count):
            for column, info in db_table_values.items():
                if column != '__infos__':
                    value = info['values'][i]
                    maxlength = int(info['length'])
                    blank_spaces = " " * (maxlength - len(value))
                    print  "| %s%s" % (value, blank_spaces),
            print "|"

        print "%s\n" % break_line
